/*
**  EPIwm
**  Copyright (C) 1999 Julien Mulot, Thomas Poindessous, Stephane Rault
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** icon_draw.c
** 
** Made by (Julien Mulot)
** Login   <mulot@epita.fr>
** 
** Started on  Sun Apr 11 17:00:15 1999 Julien Mulot
 ** Last update Sun May 23 04:06:48 1999 
*/

#include "epiwm.h"

#ifdef	  __Imlib__
void		draw_button_image(button, path)
     Window		button;
     char		*path;
{
  int		width;
  int		height;
  Pixmap	pixmap;
  Pixmap	mask;
  
  if (!(gl_epiwin.titlebar.image =
	Imlib_load_image(gl_imlib_data, path)))
    {
      fprintf(stderr, "cannot load button image %s\n", path);
      exit (1);
    }
  width = gl_epiwin.titlebar.image->rgb_width;
  height = gl_epiwin.titlebar.image->rgb_height;
  Imlib_render(gl_imlib_data, gl_epiwin.titlebar.image, 
	       width, height);  
  pixmap = Imlib_move_image(gl_imlib_data, 
			    gl_epiwin.titlebar.image);
  mask = Imlib_move_mask(gl_imlib_data, 
			 gl_epiwin.titlebar.image);
  XSetWindowBackgroundPixmap(gl_dpy, button, pixmap);
  XClearWindow(gl_dpy, button);
}
#endif

int			set_btn_position(titlebar, align, pos)
     Window		titlebar;
     short		align;
     int		pos;
{
  XWindowAttributes	attrib;
  
  XGetWindowAttributes(gl_dpy, titlebar, &attrib);
  if ((gl_epiwin.titlebar.position == TOP) 
      || (gl_epiwin.titlebar.position == BOTTOM))
    {
      if (align == ALIGN_LEFT)
	return (pos);
      if (align == ALIGN_RIGHT)
	return ((attrib.width - pos - gl_epiwin.btn_width >= 0) ?
		(attrib.width - pos) : 0);
      if (align == ALIGN_CENTER)
	return (attrib.width / 2 + pos);
    }
  else
    {
      if (align == ALIGN_LEFT)
	return (pos);
      if (align == ALIGN_RIGHT)
	return ((attrib.height - pos - gl_epiwin.btn_height >= 0) ?
		(attrib.height - pos) : 0);
      if (align == ALIGN_CENTER)
	return (attrib.height / 2 + pos);
    }
  return (0);
}

void			draw_icon_resize(button, state)
     Window			button;
     char			*state;
{
  XWindowAttributes	attrib;
#ifdef	  __Imlib__
  if (gl_epiwin.titlebar.image_btn_resize)
    draw_button_image(button, gl_epiwin.titlebar.image_btn_resize);
  else
    {
#endif
      XGetWindowAttributes(gl_dpy, button, &attrib);
      if (!strcmp("active", state))
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
			 0, 0, 2 * attrib.width / 3, 2 * attrib.height / 3);
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
			 attrib.width / 3, attrib.height / 3,
			 2 * attrib.width /3 - 1, 2 * attrib.height / 3 - 1);
	}
      else
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 0, 0, 2 * attrib.width / 3, 2 * attrib.height / 3);
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 attrib.width / 3, attrib.height / 3,
			 2 * attrib.width /3 - 1, 2 * attrib.height / 3 - 1);
	}
#ifdef	  __Imlib__
    }
#endif
}

void			draw_icon_max(button, state)
     Window			button;
     char			*state;
{
  XWindowAttributes	attrib;
#ifdef	  __Imlib__
  if (gl_epiwin.titlebar.image_btn_max)
    draw_button_image(button, gl_epiwin.titlebar.image_btn_max);
  else
    {
#endif
      XGetWindowAttributes(gl_dpy, button, &attrib);
      if (!strcmp("active", state))
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
			 0, 0, attrib.width - 1, attrib.height - 1);
	  XFillRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active, 0, 0,
			 attrib.width, attrib.height / 3);
	}
      else
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 0, 0, attrib.width - 1, attrib.height - 1);
	  XFillRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 0, 0, attrib.width, attrib.height / 3);
	}
#ifdef	__Imlib__ 
    }
#endif
}

void			draw_icon_iconify(button, state)
     Window			button;
     char			*state;
{
  XWindowAttributes	attrib;
#ifdef	  __Imlib__
  if (gl_epiwin.titlebar.image_btn_iconify)
    draw_button_image(button, gl_epiwin.titlebar.image_btn_iconify);
  else
    {
#endif
      XGetWindowAttributes(gl_dpy, button, &attrib);
      if (!strcmp("active", state))
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
			 0, 0, attrib.width - 1, attrib.height - 1);
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
			 0, attrib.height / 2,
			 attrib.width / 2 - 1, attrib.height / 2 - 1);
	}
      else
	{
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 0, 0, attrib.width - 1, attrib.height - 1);
	  XDrawRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
			 0, attrib.height / 2,
			 attrib.width / 2 - 1, attrib.height / 2 - 1);
	}
#ifdef	__Imlib__
    }
#endif
}

void			draw_icon_close(button, state)
     Window			button;
     char			*state;
{
#ifdef	  __Imlib__
  if (gl_epiwin.titlebar.image_btn_close)
    draw_button_image(button, gl_epiwin.titlebar.image_btn_close);
  else
    {
#endif
#ifdef	__Imlib__
    }
#endif
}

void			draw_icon_shade(button, state)
     Window			button;
     char			*state;
{
  XWindowAttributes	attrib;
#ifdef	  __Imlib__
  if (gl_epiwin.titlebar.image_btn_shade)
    draw_button_image(button, gl_epiwin.titlebar.image_btn_shade);
  else
    {
#endif
      XGetWindowAttributes(gl_dpy, button, &attrib);
      if (!strcmp("active", state))
	XFillRectangle(gl_dpy, button, gl_epiwin.titlebar.font_active,
		       0, attrib.height / 3,
		       attrib.width, attrib.height / 3 - 1);
      else
	XFillRectangle(gl_dpy, button, gl_epiwin.titlebar.font_inactive,
		       0, attrib.height / 3,
		       attrib.width, attrib.height / 3 - 1);
#ifdef	__Imlib__
    }
#endif
}
